import {Type} from './Type.js'

export class Implementations {
   constructor(imps) {
      this.patterns = new Map()
      for (let i = 0; i < imps.length; ++i) {
         let pattern = imps[i++]
         if (!Array.isArray(pattern)) pattern = [pattern]
         if (!pattern.every(item => item instanceof Type)) {
            throw new TypeError(
               `Implementation pattern ${pattern} contains non-Type entry`)
         }
         this.patterns.set(pattern, imps[i])
      }
   }
}

export const onType = (...imps) => new Implementations(imps)

export const Returns = (type, f) => (f.returns = type, f)

export const isPlainObject = (obj) => {
   if (typeof obj !== 'object') return false
   if (!obj) return false // excludes null
   const proto = Object.getPrototypeOf(obj)
   return !proto || proto === Object.prototype
}
